"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const moment_1 = __importDefault(require("moment"));
const mongodb_1 = require("mongodb");
const odata_v4_server_1 = require("odata-v4-server");
const connect_1 = __importDefault(require("../connect"));
const BufferItem_1 = require("./BufferItem");
const Trade_1 = require("./Trade");
const View_1 = require("./View");
class Session {
    constructor(data) {
        Object.assign(this, data);
    }
    stop(result) {
        return __awaiter(this, void 0, void 0, function* () {
            const { _id } = result;
            if (Session.streams[_id]) {
                Session.streams[_id].destroy();
                delete Session.streams[_id];
            }
            yield (yield connect_1.default()).collection("session").updateOne({ _id: new mongodb_1.ObjectID(_id) }, {
                $set: {
                    end: moment_1.default()
                        .utc()
                        .toISOString()
                }
            });
        });
    }
}
Session.streams = {};
__decorate([
    odata_v4_server_1.Edm.Key,
    odata_v4_server_1.Edm.Computed,
    odata_v4_server_1.Edm.String
], Session.prototype, "_id", void 0);
__decorate([
    odata_v4_server_1.Edm.String
], Session.prototype, "type", void 0);
__decorate([
    odata_v4_server_1.Edm.String
], Session.prototype, "exchange", void 0);
__decorate([
    odata_v4_server_1.Edm.String
], Session.prototype, "currency", void 0);
__decorate([
    odata_v4_server_1.Edm.String
], Session.prototype, "asset", void 0);
__decorate([
    odata_v4_server_1.Edm.Double
], Session.prototype, "period", void 0);
__decorate([
    odata_v4_server_1.Edm.String
], Session.prototype, "begin", void 0);
__decorate([
    odata_v4_server_1.Edm.String
], Session.prototype, "end", void 0);
__decorate([
    odata_v4_server_1.Edm.String
], Session.prototype, "indicators", void 0);
__decorate([
    odata_v4_server_1.Edm.String
], Session.prototype, "code", void 0);
__decorate([
    odata_v4_server_1.Edm.Double
], Session.prototype, "initialBalance", void 0);
__decorate([
    odata_v4_server_1.Edm.Double
], Session.prototype, "finalBalance", void 0);
__decorate([
    odata_v4_server_1.Edm.Double
], Session.prototype, "profit", void 0);
__decorate([
    odata_v4_server_1.Edm.String
], Session.prototype, "status", void 0);
__decorate([
    odata_v4_server_1.Edm.Collection(odata_v4_server_1.Edm.EntityType(odata_v4_server_1.Edm.ForwardRef(() => BufferItem_1.BufferItem)))
], Session.prototype, "Buffer", void 0);
__decorate([
    odata_v4_server_1.Edm.Collection(odata_v4_server_1.Edm.EntityType(odata_v4_server_1.Edm.ForwardRef(() => Trade_1.Trade)))
], Session.prototype, "Trades", void 0);
__decorate([
    odata_v4_server_1.Edm.EntityType(odata_v4_server_1.Edm.ForwardRef(() => View_1.View))
], Session.prototype, "View", void 0);
__decorate([
    odata_v4_server_1.Edm.Action,
    __param(0, odata_v4_server_1.odata.result)
], Session.prototype, "stop", null);
exports.Session = Session;
//# sourceMappingURL=Session.js.map