"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const event_stream_1 = __importDefault(require("event-stream"));
const odata_v4_server_1 = require("odata-v4-server");
const trader_service_1 = require("trader-service");
const Session_1 = require("./controllers/Session");
let TraderServer = class TraderServer extends odata_v4_server_1.ODataServer {
    getData(body) {
        return __awaiter(this, void 0, void 0, function* () {
            const { exchange, currency, asset, period, begin, end } = body;
            const indicators = JSON.parse(body.indicators);
            const rs = trader_service_1.streamBuffer({
                exchange,
                currency,
                asset,
                period,
                start: begin,
                end,
                indicators
            });
            const buffer = [];
            rs.pipe(event_stream_1.default.map((chunk, next) => {
                buffer.push(JSON.parse(chunk));
                next();
            }));
            return new Promise(resolve => {
                rs.on("end", () => {
                    resolve(buffer);
                });
            });
        });
    }
};
__decorate([
    odata_v4_server_1.Edm.FunctionImport(odata_v4_server_1.Edm.String),
    __param(0, odata_v4_server_1.odata.body)
], TraderServer.prototype, "getData", null);
TraderServer = __decorate([
    odata_v4_server_1.odata.cors,
    odata_v4_server_1.odata.namespace("Trader"),
    odata_v4_server_1.odata.controller(Session_1.SessionController, true)
], TraderServer);
exports.TraderServer = TraderServer;
//# sourceMappingURL=server.js.map